library Dict;

uses strings;

type
	tList2  = array[0..122] of string[2];
	tList3  = array[0..1243] of string[3];
	tList4  = array[0..5246] of string[4];
	tList5  = array[0..12049] of string[5];
	tList6  = array[0..21448] of string[6];
	tList7  = array[0..32049] of string[7];
	tList8  = array[0..39350] of string[8];
	tList9  = array[0..38378] of string[9];
	tList10 = array[0..33719] of string[10];
	tList11 = array[0..26723] of string[11];
	tList12 = array[0..19534] of string[12];
	tList13 = array[0..13385] of string[13];
	tList14 = array[0..8798] of string[14];
	tList15 = array[0..5455] of string[15];
	tList16 = array[0..3267] of string[16];
	tList17 = array[0..1817] of string[17];
	tList18 = array[0..977] of string[18];
	tList19 = array[0..513] of string[19];
	tList20 = array[0..247] of string[20];
	tList21 = array[0..102] of string[21];
	tList22 = array[0..42] of string[22];
	tList23 = array[0..25] of string[23];
	tList24 = array[0..17] of string[24];
	tList25 = array[0..6] of string[25];
	tList26 = array[0..2] of string[26];
	tList27 = array[0..3] of string[27];
	tList28 = array[0..3] of string[28];
	tList29 = array[0..3] of string[29];
	tList30 = array[0..2] of string[30];
	tList31 = array[0..2] of string[31];
	tList32 = array[0..2] of string[32];
	tList45 = array[0..2] of string[45];
	tWordCount = array[2..45] of longint;

var
	gList2:		tList2;
	gList3:		tList3;
	gList4:		tList4;
	gList5:		tList5;
	gList6:		tList6;
	gList7:		tList7;
	gList8:		tList8;
	gList9:		tList9;
	gList10:	tList10;
	gList11:	tList11;
	gList12:	tList12;
	gList13:	tList13;
	gList14:	tList14;
	gList15:	tList15;
	gList16:	tList16;
	gList17:	tList17;
	gList18:	tList18;
	gList19:	tList19;
	gList20:	tList20;
	gList21:	tList21;
	gList22:	tList22;
	gList23:	tList23;
	gList24:	tList24;
	gList25:	tList25;
	gList26:	tList26;
	gList27:	tList27;
	gList28:	tList28;
	gList29:	tList29;
	gList30:	tList30;
	gList31:	tList31;
	gList32:	tList32;
	gList45:	tList45;
	gWordCount: tWordCount;
	gTotal: longint;



procedure add_to_dictionary(s: string; l: longint);
begin
	case l of
		2       : gList2[gWordCount[2]] := s;
		3       : gList3[gWordCount[3]] := s;
		4       : gList4[gWordCount[4]] := s;
		5       : gList5[gWordCount[5]] := s;
		6       : gList6[gWordCount[6]] := s;
		7       : gList7[gWordCount[7]] := s;
		8       : gList8[gWordCount[8]] := s;
		9       : gList9[gWordCount[9]] := s;
		10      : gList10[gWordCount[10]] := s;
		11      : gList11[gWordCount[11]] := s;
		12      : gList12[gWordCount[12]] := s;
		13      : gList13[gWordCount[13]] := s;
		14      : gList14[gWordCount[14]] := s;
		15      : gList15[gWordCount[15]] := s;
		16      : gList16[gWordCount[16]] := s;
		17      : gList17[gWordCount[17]] := s;
		18      : gList18[gWordCount[18]] := s;
		19      : gList19[gWordCount[19]] := s;
		20      : gList20[gWordCount[20]] := s;
		21      : gList21[gWordCount[21]] := s;
		22      : gList22[gWordCount[22]] := s;
		23      : gList23[gWordCount[23]] := s;
		24      : gList24[gWordCount[24]] := s;
		25      : gList25[gWordCount[25]] := s;
		26      : gList26[gWordCount[26]] := s;
		27      : gList27[gWordCount[27]] := s;
		28      : gList28[gWordCount[28]] := s;
		29      : gList29[gWordCount[29]] := s;
		30      : gList30[gWordCount[30]] := s;
		31      : gList31[gWordCount[31]] := s;
		32      : gList32[gWordCount[32]] := s;
		45      : gList45[gWordCount[45]] := s;	
	end;
	inc(gWordCount[l]);
	//writeln(l, '  ', gWordCount[l]);
end;

function load_words:real; cdecl;
var i: longint;
	f: text;
	s: string[50];
	l: longint;
begin
	gTotal := 0;
	for i := 2 to 45 do gWordCount[i] := 0;
	assign(f, 'words.txt');
	reset(f);
	while (not eof(f)) do begin
		readln(f, s);
		l := length(s);
		add_to_dictionary(s, l);
		inc(gTotal);
	end;
	close(f);
	load_words := gTotal;
end;

function word_index(l, n: longint): string;
var word: string;
begin
	case l of
		2       : word := gList2[n];
		3       : word := gList3[n];
		4       : word := gList4[n];
		5       : word := gList5[n];
		6       : word := gList6[n];
		7       : word := gList7[n];
		8       : word := gList8[n];
		9       : word := gList9[n];
		10      : word := gList10[n];
		11      : word := gList11[n];
		12      : word := gList12[n];
		13      : word := gList13[n];
		14      : word := gList14[n];
		15      : word := gList15[n];
		16      : word := gList16[n];
		17      : word := gList17[n];
		18      : word := gList18[n];
		19      : word := gList19[n];
		20      : word := gList20[n];
		21      : word := gList21[n];
		22      : word := gList22[n];
		23      : word := gList23[n];
		24      : word := gList24[n];
		25      : word := gList25[n];
		26      : word := gList26[n];
		27      : word := gList27[n];
		28      : word := gList28[n];
		29      : word := gList29[n];
		30      : word := gList30[n];
		31      : word := gList31[n];
		32      : word := gList32[n];
		45      : word := gList45[n];	
	end;
	word_index := word;
end;


function is_valid_word(t: PChar): real; cdecl;
var l, pos, hi, lo: longint;
	valid: boolean;
	target: string;
begin
	target := StrPas(t);
	// use a binary search to find the word:
	valid := false;
	l := length(target);
	lo := 0;
	hi := gWordCount[l];
//	writeln('Searching for ', target, ' among ', hi, ' words.');
	pos := hi >> 1;
	while ((not valid) and ((hi - lo) > 2)) do begin
//		writeln('    hi:', hi, '  lo:', lo, '  pos:', pos);
		if (word_index(l, pos) = target) then begin
			valid := true;
		end
		else begin
			if (word_index(l, pos) < target) then begin
				lo := pos;
				pos := lo + (hi - lo) >> 1;
			end
			else begin
				hi := pos;
				pos := lo + (hi - lo) >> 1;
			end;		
		end;
	end;
	if (not valid) then begin
		// still haven't found it; we're narrowed down to the point that
		// hi, lo, and pos are consecutive, so just test those three:
		if (word_index(l, lo)  = target) then valid := true;
		if (word_index(l, hi)  = target) then valid := true;
		if (word_index(l, pos) = target) then valid := true;
	end;
	if (valid) then is_valid_word := 1.0 else is_valid_word := 0.0;
end;

//var word: string;
exports load_words, is_valid_word;

begin
{	load_words();
	writeln('Well, it didn''t crash! (', gTotal, ' words.)');
	word := '';
	while (word <> 'q') do begin
		write('>');
		readln(word);
		if (length(word) > 2) and ((is_valid_word(word) > 0)) then writeln('found!') else writeln('not found!');
	end;}
end.